{
  "cells": [
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "MeqOUBctDd32"
      },
      "source": [
        "# CS 480/680 assignment 4\n",
        "\n",
        "Tips:\n",
        "- Please save a copy of this notebook to avoid losing your changes.\n",
        "- Debug your code and ensure that it can run.\n",
        "- Save the output of each cell. Failure to do so may result in your coding questions not being graded.\n",
        "- To accelerate the training time, you can choose 'Runtime' -> 'Change runtime type' -> 'Hardware accelerator' and set 'Hardware accelerator' to 'GPU'.\n",
        "- Your grade is independent of the accuracy of your models. Your grade will depend on the correctness of your code and implementation.\n",
        "\n",
        "Tips for submission:\n",
        "- Do not change the order of the problems.\n",
        "- Select 'Runtime' -> 'Run all' to run all cells and generate a final \"gradable\" version of your notebook and save your ipynb file.\n",
        "- Also use 'File' -> 'Print' and then print your report from your browser into a PDF file."
      ]
    },
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "-uEZzFeq3VEL"
      },
      "source": [
        "##Question1 - Adversarial Training (55 points)\n",
        "\n",
        "In this assignment, you are supposed to train a model using limited data that, in addition to generalization, also possesses good robustness.\n",
        "\n",
        "\n",
        "You can add any extra libraries that you need in this cell."
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "lzFHzSZI3T7M"
      },
      "outputs": [],
      "source": [
        "import torch\n",
        "import torchvision\n",
        "import numpy as np\n",
        "from sklearn.model_selection import train_test_split\n",
        "from torchvision import transforms\n",
        "from collections import Counter\n",
        "import matplotlib.pyplot as plt\n",
        "import torchvision.models as models\n",
        "import umap\n",
        "from tqdm import tqdm\n",
        "import torch.nn as nn\n",
        "from sklearn.neighbors import KNeighborsClassifier\n",
        "from sklearn.metrics import accuracy_score\n",
        "import random"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "q7RjG9GKMeeR"
      },
      "outputs": [],
      "source": [
        "device=torch.device(\"cuda:0\" if torch.cuda.is_available() else \"cpu\")"
      ]
    },
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "65xPucx1H5Fa"
      },
      "source": [
        "###Q1.1 Load Data (5 points)\n",
        "\n",
        "In this question, you are going to use CIFAR-10 dataset. First, load this dataset, then split 20% of the data for training and the rest for validation. Make sure to maintain class balance during the split."
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "lJR768loIjGJ"
      },
      "outputs": [],
      "source": [
        "Train_SIZE = 0.2\n",
        "cifar_transforms = transforms.Compose(\n",
        "    [transforms.ToTensor(),\n",
        "     transforms.Normalize()])\n",
        "cifar_trainset = torchvision.datasets.CIFAR10(root='./data', train=True, download=True)\n",
        "cifar_testset = torchvision.datasets.CIFAR10(root='./data', train=False, download=True)\n"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "5v_KiWmyH57Q"
      },
      "outputs": [],
      "source": [
        "class Cifar10Dataset(torch.utils.data.Dataset):\n",
        "\n",
        "    def __init__(self,dataset,idx,transforms=None):\n",
        "        self.idx = idx\n",
        "        self.transforms = transforms\n",
        "        self.data = torch.utils.data.Subset(dataset, idx)\n",
        "\n",
        "    def __getitem__(self,index):\n",
        "        image,label = self.data[index]\n",
        "        if(self.transforms!= None):\n",
        "            image = self.transforms(image)\n",
        "\n",
        "        return image,label\n",
        "\n",
        "    def __len__(self):\n",
        "        return len(self.data)\n",
        "\n",
        "#Split data and create the dataloader"
      ]
    },
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "dqqxZWaTI-MN"
      },
      "source": [
        "###Q1.2 Train Model (15 points)\n",
        "\n",
        "Train a ResNet18 model using the cross-entropy loss function, and report its accuracy on validation and test datasets.\n",
        "\n",
        "After that, reduce the dimensionality of the output of the backbone of the network and visualize it for the unseen data. You can use UMAP for dimensionality reduction. Note that for this task, you are not allowed to use the labels."
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "pqOPow3GJWK5"
      },
      "outputs": [],
      "source": [
        "class Resnet18(nn.Module):\n",
        "    def __init__(self, num_classes,normalize = False):\n",
        "        super().__init__()\n",
        "        #To do\n",
        "\n",
        "    def forward(self, x):\n",
        "        #To do"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "lMx0pg8wLnu6"
      },
      "outputs": [],
      "source": [
        "def train(model,data_loader,criterion,optimizer,attack = False):\n",
        "\n",
        "    with tqdm(data_loader, desc =\"   train\") as train_tqdm:\n",
        "        for batch_idx, (inputs, targets) in enumerate(train_tqdm):\n",
        "            model.train()\n",
        "            inputs, targets = inputs.to(device), targets.to(device)\n",
        "            #To do\n",
        "\n",
        "    return average_train_loss, accuracy"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "XQHlLDKZPl_h"
      },
      "outputs": [],
      "source": [
        "def test(model,data_loader,criterion,optimizer,attack=False):\n",
        "    model.eval()\n",
        "\n",
        "    with tqdm(data_loader, desc =\"   test\") as test_tqdm:\n",
        "        for batch_idx, (inputs, targets) in enumerate(test_tqdm):\n",
        "            inputs, targets = inputs.to(device), targets.to(device)\n",
        "            #To do\n",
        "\n",
        "    return average_test_loss, accuracy"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "F4wEAQeSQDYi"
      },
      "outputs": [],
      "source": [
        "def plot_umap(features,y):\n",
        "    #To do"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "FYEOb6fCCqrk"
      },
      "outputs": [],
      "source": [
        "plot_umap(features,y_test)"
      ]
    },
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "nXmFv52CQcFv"
      },
      "source": [
        "###Q1.3 Adversarial Test (15 points)\n",
        "\n",
        "\n",
        "In this section, you are required to change the unseen data before calculating the accuracy of them from the output image of the backbone. Compare the results with the previous section. Your changes should include data augmentations such as adding Gaussian noise, color jitter, etc. Additionally, you should apply an adversarial attack such as fast gradient method on the network. You can use the cleverhans library for this purpose."
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "iWJR4PjlQdgY"
      },
      "outputs": [],
      "source": [
        "augmentation = transforms.Compose([\n",
        "    #To do\n",
        "                                   ])"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "_ufOAvjOA093"
      },
      "outputs": [],
      "source": [
        "def generate_fgm_examples(model,data_loader,criterion):\n",
        "    model.eval()\n",
        "    with tqdm(data_loader) as test_tqdm:\n",
        "        for batch_idx, (inputs, targets) in enumerate(test_tqdm):\n",
        "            inputs, targets = inputs.to(device), targets.to(device)\n",
        "            #To do\n",
        "\n",
        "\n",
        "\n",
        "    return examples,labels"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "rMCtqJAwBG7O"
      },
      "outputs": [],
      "source": [
        "advx_test,advy_test = generate_fgm_examples()\n",
        "plot_umap(features,advy_test)"
      ]
    },
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "-t4CSzKSIZJ2"
      },
      "source": [
        "##Q1.4 Adversarial Train (20 points)\n",
        "\n",
        "\n",
        "In this section, you should repeat the experiments on parts two and three using adversarial examples and compare the results. Here, the training data will be modified using augmentations and adversarial attack."
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "PiFE7gspI9nM"
      },
      "outputs": [],
      "source": [
        "#Train resnet18 using the adversarial examples"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "W0r_M1-bIYaN"
      },
      "outputs": [],
      "source": [
        "plot_umap(features,y_test)"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "3Me9VJP3JDsO"
      },
      "outputs": [],
      "source": [
        "plot_umap(features,advy_test)"
      ]
    },
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "rA9ueCHhJSM7"
      },
      "source": [
        "##Question2 - Diffusion Model (45 points)\n",
        "\n",
        "This homework helps you implement a Denoising Diffusion Probabilistic Model (DDPM).  \n",
        "\n",
        "\n",
        "\n",
        "You can add any extra libraries that you need in this cell."
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "1ISyKSLZygOQ"
      },
      "outputs": [],
      "source": [
        "import torchvision\n",
        "from torchvision import transforms\n",
        "import pandas as pd\n",
        "import numpy as np\n",
        "import transformers\n",
        "import torch\n",
        "from torch.utils.data import Dataset, DataLoader, random_split\n",
        "from tqdm import tqdm\n",
        "import torch.nn as nn\n",
        "from matplotlib import pyplot as plt\n",
        "from PIL import Image\n",
        "from keras.datasets import cifar10\n",
        "from diffusers import UNet2DModel"
      ]
    },
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "0SCFb5hvyfXV"
      },
      "source": [
        "###Q2.1 Load Data (5 points)\n",
        "\n",
        "In this question, you are going to use one arbitrary class of CIFAR-10 dataset. First, load this dataset, then choose any class you want and use that for the rest of this question."
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "KO_a_wWDyaXz"
      },
      "outputs": [],
      "source": [
        "#Load the data and choose one class, then create the data loader."
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "gcRsvgtY94tI"
      },
      "outputs": [],
      "source": [
        "class CustomDataset(Dataset):\n",
        "    def __init__(self, images, transform=None):\n",
        "        #To do\n",
        "\n",
        "    def __len__(self):\n",
        "        return len(self.images)\n",
        "\n",
        "    def __getitem__(self, idx):\n",
        "        #To do\n",
        "        return  image\n",
        "\n",
        "\n",
        "preprocess = transforms.Compose([\n",
        "    transforms.ToTensor(),\n",
        "    transforms.Normalize([0.5], [0.5])\n",
        "])\n",
        "\n",
        "dataloader ="
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "VBt3lnzAQAa_"
      },
      "outputs": [],
      "source": [
        "def show_images(x):\n",
        "    x = x * 0.5 + 0.5\n",
        "    grid = torchvision.utils.make_grid(x)\n",
        "    grid = grid.detach().cpu().permute(1, 2, 0).clip(0, 1) * 255\n",
        "    grid = Image.fromarray(np.array(grid).astype(np.uint8))\n",
        "    return grid"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "li9k_88v_-fW"
      },
      "outputs": [],
      "source": [
        "x_test = next(iter(dataloader))[:6]\n",
        "show_images(x_test).resize((8 * 64, 64), resample=Image.NEAREST)"
      ]
    },
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "WDzHxciJATXN"
      },
      "source": [
        "###Q2.2 Forward pass (10 points)\n",
        "\n",
        "In this section, you are going to implement the forward pass of your diffusion model. You can use diffusers library for this task. Then use show_images function to plot your target image at different times of the forward pass. (Simply use the default hypermeters mentioned in the DDPM paper or the default values of the diffuser library. Visualising images every 100 steps is enough)"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "LXcjXLUfBJUm"
      },
      "outputs": [],
      "source": []
    },
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "47qTkfQRH9Yt"
      },
      "source": [
        "###Q2.3 Denoising (15 points)\n",
        "\n",
        "In this section, you will implement the denoising part of your diffusion model. First, create a U-net and train it on your CIFAR10 data. Then, start from random noise and plot the denoised images of 6 random samples. (In the DDPM paper Sec 3.3, they also trained a reverse process decoder. You are not required to implement it in this assignment. Visualizing the outputs of the diffusion network is sufficient.)"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "7e6gQANaJ9-m"
      },
      "outputs": [],
      "source": [
        "model = UNet2DModel(\n",
        "    #To do\n",
        " )"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "j_K8ic9cKeWp"
      },
      "outputs": [],
      "source": [
        "def train(model,data_loader,criterion,optimizer):\n",
        "\n",
        "    with tqdm(data_loader, desc =\"   train\") as train_tqdm:\n",
        "        for batch_idx, inputs in enumerate(train_tqdm):\n",
        "            model.train()\n",
        "            inputs = inputs.to(device)\n",
        "            #To do\n",
        "\n",
        "    return average_train_loss"
      ]
    },
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "YwxxnkyaK3zz"
      },
      "outputs": [],
      "source": [
        "sample = torch.randn(6, 3, 32, 32).to(device)\n",
        "\n",
        "#denoise\n",
        "\n",
        "show_images(sample)\n"
      ]
    },
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "SV8eXSQ-Lkvj"
      },
      "source": [
        "###Q2.4 Conditional Equation (15 points)\n",
        "\n",
        "In this part, you should express $\\alpha_t$ in terms of the values of $\\beta_i$, in the following equation:\n",
        "\n",
        "$$q(z_t|z_0) = \\mathcal{N}(z_t; \\sqrt{\\alpha_t}z_0, (1-\\alpha_t)I)$$\n",
        "\n",
        "Take this into account that the conditional variance for the one step forward diffusion (the following equation) at time t is given by $\\beta_t$.\n",
        "\n",
        "$$q(z_t|z_{t-1}) = \\mathcal{N}(z_t; \\sqrt{1-\\beta_t}z_{t-1}, \\beta_tI)$$"
      ]
    },
    {
      "cell_type": "markdown",
      "metadata": {
        "id": "25GBfT2pRQtO"
      },
      "source": [
        "solution:"
      ]
    }
  ],
  "metadata": {
    "colab": {
      "provenance": []
    },
    "kernelspec": {
      "display_name": "Python 3",
      "name": "python3"
    },
    "language_info": {
      "name": "python"
    }
  },
  "nbformat": 4,
  "nbformat_minor": 0
}
